#!/bin/bash
#
# /include_functions/file_tools.inc
#
# -replace_line()
#
#------------------------

#-------------
find_section()
#-------------
{
	local _section=$1
	local _line=$2
	local _lg=${#_section}
	local return_value=1

	#echo $_lg":"$_section
	if [[ "$_section" == "${_line:0:_lg}" ]]
	then
		return_value=0
	fi
	return $return_value
}

#--------------------
insert_line_to_file()
#--------------------
{
	local _line_nr=$1
	local _line=$2
	local _file=$3
	sed -i "$_line_nr a \\$_line" $_file
}

#--------------------
del_line_in_file()
#--------------------
{
	local _line_nr=$1
	local _line=$3
	local _file=$2

	# _line_nr = 3,5 "d"
	# _line_nr = 3,$ "d"

	sed -i "$_line_nr""d" $_file
}


#-----------------
replace_one_line()
#-----------------
{
	local original_line=$1
	local replace_line=$2
	local _file=$3

	sed "/$original_line/c '$replace_line" $_file > $_file.tmp
	sleep 0.25
	cp "$_file.tmp" "$_file"
	rm "$_file.tmp"

}

#------------------
rows_of_screen_nr()
#------------------
{
	local sc_nr=$1
	local return_value=0

	case $sc_nr in
		1 )	return_value=$TOTAL_NUMBER_OF_FIELDS_MASK_1
			;;
		2 ) return_value=$TOTAL_NUMBER_OF_FIELDS_MASK_2
			;;	
		3 ) return_value=$TOTAL_NUMBER_OF_FIELDS_MASK_3
			;;	
		4 ) return_value=$TOTAL_NUMBER_OF_FIELDS_MASK_4 # usw. bis screen_nr 9
			;;							
	esac
	echo $return_value
}

#------------------------------
write_array_to_finished_file()
#------------------------------
{

	local i=0
	local z_nr=1
	local lg=${#global_array[*]}
	local search_obj=""
	local temp=""
	local from_file=$f_data_01

	if [ -f $f_data_04 ]
	then	
		rm -f $f_data_04
	fi	
	for (( i; $i < $lg; i++ ))
	do
		search_obj="field_"$z_nr'='
		temp=$(grep $search_obj $from_file)
		temp=${temp#field_*=\"}   	# Abschneiden " field_*=\n "
		temp=${temp%\"*}
		echo $temp${global_array[$z_nr]} >> $f_data_04
		z_nr=$((z_nr + 1 ))
	done	

}

#------------------------------
copy_dummy_file_to_input.data()
#------------------------------
{
	local row_line=""
	local i=0
	local tmp=""
	local array_string=""
	local return_value=""

	while read row_line
	do
		if [[ $row_line =~ "net0" ]] || [[ $row_line =~ "net1" ]]
		then
			i=$((i +1 ))	
			tmp=$(find_prae_post_string "$row_line" "=" "po" "net0") 
			# wichtig "row_line" -> "23 Uhr", Space in übegebender Zeile!
			echo "field_"$i"="$tmp >> $f_data_03      #"$(pwd)/kassenlog/input.data"
			array_string=$array_string" "$tmp
		fi
	done < $f_data_01

	return_value=$array_string
	echo $return_value
}

#------------------
search_start_line()
#------------------
{
	local line=$1
	local search_obj=$2
	return_value=1  # nicht gefunden

	if [[ "$search_obj" == "${line:0:6}" ]]
	then
		return_value=0
	fi	
	echo $return_value
}

#----------
read_text()
#----------
{
	local file=$1 			# File
	local z_lg=$2 			# laenge der festgelegten Zeilenlaenge für Druckbereich
	local line=""
	local line_lg=0
	local i=0 
	local z=0
	local start_pos_x=$4      # Höhe=Spalte
	local start_pos_y=$3      # Höhe=Zeile
	local page_nr=$5
	local act_line_nr=0      # aktuelle LineNummer in Bearbeitung
	local anz_part_line=0

	
	declare -a text_array

	while read line
	do
		act_line_nr=$((act_line_nr+1))
		line_lg=0
		text_array=() 
		line_lg=${#line}
		anz_part_line=0
		
		# wieviel teil-string hat die Zeile
		anz_part_line=$(( line_lg / z_lg ))
		if (( $((line_lg % z_lg)) > 0 ))
		then
			anz_part_line=$((anz_part_line+1))	
		fi
		#--------------------------------------------------
		if (( $line_lg <= $z_lg ))
		then
			z=0
			text_array[$act_line_nr]="${line:z:z_lg}"
			goto_xy_write $((start_pos_y+act_line_nr)) $start_pos_x "${text_array[$act_line_nr]}"
		else
			z=0
			for ((i=0;i<=$anz_part_line;i++ ))
			do
				text_array[$i]="${line:z:z_lg}"
				echo "${text_array[$i]}" >> txt-01.txt
				goto_xy_write $((start_pos_y+act_line_nr)) $start_pos_x "${text_array[$i]}"
				act_line_nr=$((act_line_nr+1))
				z=$((z+z_lg))
			done	

		fi
		if (( $act_line_nr > $help_zeilen_anz ))
		then
			break
		fi
		  
	done < "$file"
	
}
#--------------
file_to_array()
#--------------
{
	mask_array_nr=$1
	declare -A mask_array

	mask_array=($(<"$(pwd)/var/network_config.dat"))   
	echo ${mask_array[*]}
}

