#!/bin/bash
#
# include:
# logging.inc
# 
# ---------------------------------


logging()
{
   
   . const/fix_variable

   local number=$1
   local function=$2
   local messages="ERROR"
   local message_date=""
   local message_note=""
   local dummy="         "


   if [ -z $function ]
   then
      function="*"
   fi 
   
   if [ $number -ge 900 ]  2>>/dev/null
   then
      messages="ERROR-INFOS"
      log_filename=$log_err
   else
      messages="INFOS"  
      log_filename=$log_data 
   fi
   
   
   case "$1" in

        ######### Info Messages #########
        0) message_note="Starte das Programm"
          ;;
	
	    1)      
	      message_note="Info über Tastatureingabe"
	      ;;

	    2)
	      message_note="Falsches Betriebssystem OS!"
	      ;;
        3)
          message_note="Fehlerhafte Netzwerkangaben!"
          ;; 
        4)
          message_note="Preparing des System OS ist nicht notwendig"
          ;;    
        5)
          message_note="Konfiguration wird durchgeführt."
          ;;            
        6)
          message_note="Erstelle Copy von aktiver WLAN -> /etc/NetworkManager/system-connections/0-aktive_wlan"
          ;;            
        7)
          message_note="P"
          ;;            

        ######### Error Codes #########
        900)
             message_note=""
	        ;;
	        
	    901)
             message_note=""
	        ;; 
	    902)
             message_note=""
	        ;; 
        926)
             message_note="Falsche FIX_IP Konfiguration!"
            ;;     	 
        927)
             message_note="Programm mit Taste [ESC] abgebrochen!"
            ;;   
        928) message_note="Endscheiden Sie sich für DHCP oder FIX-IP, beides geht nicht zur gleichen Zeit!"
            ;;                      
	    929) message_note="Endscheiden Sie sich für DHCP oder FIX-IP, eine Option muss ausgewaehlt werden!"
            ;; 
        930) message_note="Keine Dateien fuer NetworkManager und Netplan vorhanden! Programm_Abbruch!"
            ;;             
        999)
             message_note=""
	        ;;
	         
        9999)
             message_note="Kein passendes OS für Installation gefunden!"
            ;;

      111111)
             message_note="Programm beendet durch j aus Frage j/n -> exit"
            ;;


        *)
             #message_note="Unbekannter Fehler!"
             message_note="nur zur Information: Was ist passiert!"
            ;;
          
    esac
   
   #message_date=$(date "+%d.%m.%Y | %H:%M:%S : ->")
   message_date=$(real_time dw)" | "$(real_time t)" : ->"
   message_date=" $message_date $messages "[" $number "]""

   mkdir -p $path_log
   printf "$message_date <<$function>> $dummy $message_note $CRLF" >> $path_log/$log_filename

}
