#!/bin/bash
#
# include:
# mask_draw.inc
# 
# ---------------------------------

pos_x_y()
#--------
{
  local z=$1
  local s=$2
  echo -en "\033["$z";"$s"H" 
}



show_screen_index_char()
{
	local index_char=$1
	local laenge_txt=${#index_char}
	local pos_x=0
	local j=1
	
	#-------------------------------------------------------------------------------------------------------------------------------
	sed '/mask_anz_index=/c mask_anz_index=['$j','$index_char']' const/fix_change_mask_variable > const/fix_change_mask_variable.tmp
	cp "const/fix_change_mask_variable.tmp" "const/fix_change_mask_variable"
	rm "const/fix_change_mask_variable.tmp"
	#-------------------------------------------------------------------------------------------------------------------------------
	pos_x=$(($screen_mask_pos_x + 2))
	goto_xy_write $screen_mask_pos_y $pos_x "$CHAR_LINE$CHAR_LINE$CHAR_LINE$CHAR_LINE$CHAR_LINE"
	goto_xy_write $screen_mask_pos_y $pos_x "$BG_RED$FONTS_YELLOW"["$index_char"]"$RESET"
}



#----------
draw_line()
#----------
{
  local tmp=0
  local tmp_char=$3
  local anz=$2
  local line_enter=$1
  local corner_right=$5
  local corner_left=$4
  local place=$6
  
  for (( tmp=1;$tmp<=$line_enter;tmp++ ))
  do
    printf "$_SPACE"
  done
  
  if [ $corner_left != $DUMMY  ]
  then
	  if [ -n "$corner_left"  ]
	  then
		  printf $corner_left 
	  else
		  printf $WALL_Line      
	  fi  
  fi
    
  for (( tmp=1;$tmp<=$anz;tmp++ ))
  do
    if [ -n $tmp_char ]
    then
       printf "$tmp_char"
    else
       printf "$_SPACE"
    fi
  done 
  if [ $corner_right != $DUMMY  ]
  then
	  if [ -n "$corner_right"  ]
	  then
		  printf $corner_right 
	  else
		  printf $WALL_Line          
	  fi 
  fi   
  printf $CRLF
}	


#--------------------
window_screen_frame()
#--------------------
{
	. const/fix_variable_screen-mask
	local i=1
	
	clear

	draw_line $screen_mask_pos_x $screen_mask_breite "$_SPACE" $DUMMY $DUMMY
	draw_line $screen_mask_pos_x $screen_mask_breite $CHAR_LINE $CORNER_LEFT_UP $CORNER_RIGHT_UP
	for (($i;i <= $NUMBER_OF_LINES_Screen_Frame; i++))
	do
		draw_line $screen_mask_pos_x $screen_mask_breite "$_SPACE" $WALL_Line $WALL_Line
	done
	draw_line $screen_mask_pos_x $screen_mask_breite $CHAR_LINE $CORNER_LEFT_DOWN $CORNER_RIGHT_DOWN
	
}

#--------------
goto_xy_write()
#--------------
{
	local zeile_raw=$1
	local spalte_col=$2
	local line=$3$ #4$5$6$7$8$9
	#local line=$@
	local anz=$#
	local tmp=0   # am 2021.11.02 hinzugefügt
	
	printf "\e[%d;%dH" $zeile_raw $spalte_col 
	if [ -n "$line" ]
	then
	   line="$1"; shift 
       line="$1"; shift 
       for  (( tmp=1;$tmp<=($anz-2);tmp++ ))
       do
         line="$1"; shift
         if [ $tmp -lt $anz ]
         then
             printf "%s ""${line}" 
         else
             printf "${line}"
         fi    
       done
    fi
}

#--------------
file_to_array()
#--------------
{
	mask_array_nr=$1
	declare -A mask_array

	mask_array=($(<"$(pwd)/var/network_config.dat"))   
	echo ${mask_array[*]}
}

#----------------
build_file_name()
#----------------
{
	local file=$1
	local char=$2
	local format=$3		   # z.B.: file-xx hier: Wert 2
	local dummy=""

	if [[ -z $format ]] 
	then
			file=${file::-2} 
	else 
		  file=${file::-$format}
			
	fi	
	if (( $char <= 9 )) # lfd.Nr immer 01,02,...,09,10,11,..
	then
		 file=$file"0"$char		 
	fi	
	echo $file
}

#-------------
mask_draw()
#-------------
{
	  . const/fix_change_mask_variable
	  . include_functions/string_tools.inc
	  . include_functions/file_tools.inc
	  . include_functions/mask_data_values.inc

	  local screen_nr=$1
	  local screen_header_1=$2 
	  local screen_header_2=$3
	  local sprung_code=$4
	  local zeilen_nr=1
	  local _str=""
	  local _str_=""
	  local z=0
	  local x=0
	  local y=0
	  local w=0
	  local rv=""
	  local mp=""
	  local return_value=0
	  local answer=0
	  local help_site_nr=1


	  if [[ -z $screen_nr ]]
	  then
	  		screen_nr=1                # [1] im Kopfleiste, links
	  fi
	  if [[ -z $screen_header_1 ]]
	  then
	  		screen_header_1=$screen_mask_header_text_01
	  fi

	  if [[ -z $screen_header_2 ]]
	  then
	  		screen_header_2=$ComputerTyp_Target	
	  fi
	  if [[ -z $sprung_code ]]
	  then
	  		sprung_code=0
	  fi
    window_screen_frame  	# zeichnet Framegröße der Maske
    show_screen_index_char "$screen_nr" 
    z=$( zentriere_text "$screen_header_1" "$screen_mask_breite" ) # $screen_header_x = in Anführungzeichen, damit Texte mit Leerzeichen möglich sind! z.B: Hello World									   
	  
	  goto_xy_write $masken_header_pos_y $z "$BG_BLUE1 $screen_header_1 $RESET"
	  z=$( zentriere_text "$screen_header_2" "$screen_mask_breite" )
	  
	  goto_xy_write $(($masken_header_pos_y + 1)) $z "$BG_BLUE1 $FONTS_YELLOW"$screen_header_2"$RESET"
	  
	  if (( $screen_nr < 99 ))
	  then	
		  w=$(rows_of_screen_nr $screen_nr)       # file_tools.inc

		  for ((zeilen_nr; zeilen_nr <= $w; zeilen_nr++))
		  do
		  	_str=${mask_text_array[0,$zeilen_nr]}
		  	goto_xy_write $(($masken_text_pos_y + $zeilen_nr)) $masken_text_pos_x $_str 
		   	_str_=${mask_text_array[1,$zeilen_nr]}

		   	_str_=$(show_default_value_netz_parameter $_str_ "r" $zeilen_nr)

		   	_str_=$BLUE_BLACK$_str_$RESET
		  	goto_xy_write $(($masken_text_pos_y + $zeilen_nr)) $(($masken_text_pos_x+${#_str}+1)) $_str_ 
		  done 
		else
		 while true  # HelpSystem
		 do	
		 	 #---------------------------- Breite -----------
		 	 #show_screen_index_char "$help_site_nr" 
			 read_text "$f_data_99" $((screen_mask_breite-3)) $help_text_zeile $help_text_spalte #5 11 # <-- per Hand die Werte x y anpassen
			 z=$(($NUMBER_OF_LINES_Screen_Frame + 2))
		   x=$(zentriere_text "$mask_text_question_help" "$screen_mask_breite" )
		   goto_xy_write $z $x "$mask_text_question_help  [ ]" 
		   y=${#mask_text_question_help}
		   y=$((y + x + 2))
		   desicion_answer w n $z $y "27" 1 
		   answer=$?
		   if (( $answer == 1 ))   # n=abbruch
		   then	
		   	  answer=$((answer+1))
		   	  break								 # Exit-Sprung aus while-loop!
		   fi	
		   if (( $answer == 2  )) && (( $((help_site_nr-2)) >= 0  )) # answer=r
		   then	
		   				help_site_nr=$((help_site_nr - 2))
		   				answer=0
		   fi	
		   if (( $answer == 0 ))	 # w=nochmal Help
		   then
		   	  help_site_nr=$((help_site_nr + 1))	
		   		f_data_99=$(build_file_name $f_data_99 $help_site_nr)
		   		if [ -e $f_data_99 ]
		   		then	
		   				read_text "$f_data_99" $((screen_mask_breite-3)) $help_text_zeile $help_text_spalte #$help_site_nr #5 11 # <-- per Hand die Werte x y anpassen
		   		else 
		   				help_site_nr=$((help_site_nr - 1))
		   				f_data_99=$(build_file_name $f_data_99 $help_site_nr)
		   		fi
		   fi	
		
	   done	

	   return $answer
	  fi

	  #---------- Fragestellung --------------------------------------
	  z=$(($NUMBER_OF_LINES_Screen_Frame + 2))
	  x=$(zentriere_text "$mask_text_question" "$screen_mask_breite" )
	  goto_xy_write $z $x "$mask_text_question [ ]" 
	  y=${#mask_text_question}
	  y=$((y + x + 3))
	  if (( $sprung_code == 0 ))
	  then	
	 			desicion_answer j n $z $y "27"
	 			return $?
	  fi

	  #---------------------------------------------------------------
	
}