#!/bin/bash
#
#
# include:
# include_functions/netz_part_1.inc
#-----------------------------------



save_dir()
{
	local switch1=$1     # dhcp/fix_ip
	local switch2=$2 	 # nm/np
	local save_nr=0
	local search_file=""
	local search_path=""
	local save_filename="/save-"
	
	if [[ "$switch2" == "nm" ]]
	then 
		# nm-connection-editor !!!
		# sudo service network-manager restart
		
		# "nm"
		search_path="/""$f_data_12"
		if [ ! -d $search_path ]
		then
			# Verz. gibt es noch nicht!
			mkdir "/"$search_path
			zip -qr "/"$search_path$save_filename$save_nr "/""$f_data_09" 
			#rm /$f_data_09/*.*
		else
			# Verz.gibt es schon!
			for (( save_nr ; $save_nr < 99; save_nr++ ))
			do
				if [ ! -f $search_path$save_filename$save_nr".zip" ]
				then 	
					break
				fi		
			done	
			# alte Dateien sichern
			zip -qr "/"$search_path$save_filename$save_nr "/""$f_data_09" 
			# alte Dateien löschen
			rm /$f_data_09/*.*
			#rm $f_data_09a/*.*
			#rm /run/NetworkManager/system-connections/*.*
		fi	
		
	else
		# "np"
		#echo "++ np ++" > dump.del
		search_path="$f_data_10"
		if [ ! -d $search_path ]
		then
			# Verz. gibt es noch nicht!			
			mkdir $search_path
			zip -qr $search_path/$save_filename$save_nr "$f_data_11" 
			rm "/"$f_data_08   2>/dev/null
			#rm $f_data_09a/*.* 2>/dev/null         #/run/NetworkManager/system-connections/*.*
			rm /run/NetworkManager/system-co* 2>/dev/null
		else
			# Verz.gibt es schon!
			for (( save_nr ; $save_nr < 99; save_nr++ ))
			do
				if [ ! -f $search_path$save_filename$save_nr".zip" ]
				then 	
					break
				fi		
			done	
			zip -qr /etc/netplan-save$save_filename$save_nr "$f_data_11"  
			rm "/"$f_data_08
			#rm $f_data_09a/*.* 2>/dev/null
			rm /run/NetworkManager/system-co* 2>/dev/null

		fi	
	fi	
    

}

exist_software_on_system()
{
	local search_software=$1
	local temp_dat="temp.tmp"
	local found_value=0
	local return_value=0

	apt list --installed 2>/dev/null | grep "$search_software" > $temp_dat
	found_value=$(stat -c %s $temp_dat)
	if (( $found_value >= ${#search_software} ))
	then 
		return_value=0 # Network_Manager ist installiert
	else
        return_value=1 # Network_Manager ist nicht installiert
	fi	
	rm $temp_dat
	echo $return_value
}

netz_Managerart()
{
 	. include_functions/netz_install_netplan.inc
	. include_functions/netz_install_networkmanager.inc
	#. include_functions/section_tools.inc

	local ip_vergabe=$1
	local path_1=$path_netz    # fix_variable
	local netz_path_1=$path_1"/""NetworkManager/system-connections"
	local netz_path_1a=$path_1"/""NetworkManager/"
	local netz_path_2=$path_1"/""netplan"
	local anz_f_1=0
	local anz_f_2=0
	local anz=0
	local switch=0
	local netz_software=""
	local nm_activated=1 # nm installiert, aber noch kein DEV zugordnet (wlp3s0/eth1)
	local return_value=0
	local rv=0
    


	if [[ -d $netz_path_1 ]] # Wenn ein NetworkManger installiert ist!
	then
		touch $netz_path_1"/0.0"
		anz_f_1=$( find $netz_path_1 -maxdepth 1 -type f -name "*.*"| wc -l )
		switch=$(exist_software_on_system "network-manager-*")
		touch $netz_path_1"/0.0"
	fi

	#echo $switch "-" $anz_f_1 
	

	anz_f_2=$( find $netz_path_2 -maxdepth 1 -type f -name "*.yaml"| wc -l )

	if (( $switch == 0 )) && (( $anz_f_1 > $anz ))
	then 
		#Network_Manager ist installiert!
		netz_software="nm" 
		#echo #Dateien anlegen
		save_dir $ip_vergabe $netz_software
		
		touch $netz_path_1"/0.0"
		network_manager_active $ip_vergabe
		rv=$?
		if (( $rv == 226 ))
		then
			goto_xy_write 30 10 "Fehler: Falsche Konfiguration für Fix_IP !$CRLF"
			goto_xy_write 31 10 "                        "   
			error_code=926
			logging $error_code $function_name
			sleep 4
			goto_xy_write 30 10 "                                                              $CRLF"
			goto_xy_write 31 10 "                        "   
			return 226
		fi	

		# Eine *.yaml muss angelegt werden, damit NM funktioniert!!
		echo "network:" > $netz_path_2$f_data_13
		echo "  renderer: NetworkManager" >> $netz_path_2$f_data_13
		echo "  version: 2" >> $netz_path_2$f_data_13
	else
		# netplan ist aktiv
		#goto_xy_write 32 5 "netplan modifiziert"
		if (( $anz_f_1 == 0 )) && (( $anz_f_2 == 0 ))
		then 
			goto_xy_write 30 10 "Fehler: Dateien für NetworkManger und Netplan nicht vorhanden!$CRLF"
			goto_xy_write 31 10 "        Programm-Abbruch!"   
			error_code=930
			logging $error_code $function_name
			sleep 4
			goto_xy_write 30 10 "                                                              $CRLF"
			goto_xy_write 31 10 "                        "                                        
		else	
			if (( $anz_f_2 > $anz ))
			then 
				#netplan_is_installed
				netz_software="np" 
				# dateien anlegen
				save_dir $ip_vergabe $netz_software
				netplan_active $ip_vergabe # Steuerdaten nur netplan!!
				# Eine *.yaml muss angelegt werden, damit NM funktioniert!!
				echo "network:" > $netz_path_2$f_data_13
				echo "  renderer: NetworkManager" >> $netz_path_2$f_data_13
				echo "  version: 2" >> $netz_path_2$f_data_13
				switch=1   
			fi
		fi	
	fi	
   	return_value=$switch

}

auswertung_netz_optionen()
{
	local file=$1
	local _return_value=$2
	local dhcp=0
	local fix_ip=0
	local i=0
	local function_name=${FUNCNAME[0]}
	local error_code=0
	local search_element=""
	local anz_elemente_netz_array=0
	local array_element=""	# einzelnes Element des netz_array
	local vr=0
	declare -a netz_array	# Netzwerk_Parameter


	# Einlesen des netz_array 
	while read array_element
	do
		netz_array[$i]="$array_element"
		i=$((i+1))
	done < "$file"	
	anz_elemente_netz_array=$((i-1))
	i=0

	search_element="dhcp=[X]"
	if [[ " ${netz_array[*]} " =~ " ${search_element} " ]]; then
    	# flag für dhcp ist gesetzt!
    	dhcp=1
	fi
	search_element="fix_ip=[X]"
	if [[ " ${netz_array[*]} " =~ " ${search_element} " ]]; then
    	# flag für fix_ipaddress ist gesetzt!
    	fix_ip=1
	fi
	

	if (($fix_ip == 1)) && (($dhcp == 1))	
	then
		# Positionierung zentrierung von Maske vornehen!
		goto_xy_write 31 20 "Fehler: DHCP und FIX_IP angekreuzt! "
		error_code=928
		logging $error_code $function_name
		sleep 4
		goto_xy_write 31 20 "                                    "
		return 0 # bleibt in Maske!
	else
		if (($fix_ip == 0)) && (($dhcp == 0)) && (( $return_value != 1 ))	
		then

			goto_xy_write 31 20 "Fehler: Keine Auswahl für DHCP oder FIX_IP vorgenommen!" 
			error_code=929
			logging $error_code $function_name
			sleep 4
			goto_xy_write 31 20 "                                    "
			return 0
		fi	
	fi	
	
	if (( $dhcp == 1 ))
	then
		goto_xy_write 31 20
		netz_Managerart "dhcp"
		goto_xy_write 31 20 "                                    "
	fi	
	if (( $fix_ip == 1 ))
	then
		goto_xy_write 32 20
		netz_Managerart "fix_ip"
		vr=$?
		if (( $vr == 226 ))
		then 
			return 0 # bleibt in Maske!
	    fi		
		#goto_xy_write 32 20 "                                    "
	fi	
	
	return 1  # Verlässt Maske,Programm wird beendet!
}
