#!/bin/bash
#
# Program: time_tools
# ProgramArt: SP      # AL=Standalone, SP=SubProgramm, INC=IncludeProgramm, ALR=StandaloneRemote
# Version: 1.0.0
# Begin_Development: 18.10.2021
# Develop_Change: 18.10.2021
#-------------------------------
# Author: Uwe von Royen by UvRNC
#-------------------------------
# Develop-OS: 
# Hardware: Intel/AMD Linux-PC + EPSON TM-T8xx Drucker
#
# ArrayIndex
# 		[0]		d,D   = Datum			
# 		[1]		w,W   = Wochentag
# 		[2]		Dw,DW = Wochentag,Datum
# 		[2]		dw,dW = Wochentag,Datum
#		[3]		t,T   = Uhrzeit
# 		[4]     m,M   = Monat
#------------------------------------------------------
# include_functions/time_tools.inc



#----------
real_time()
#----------
{
	local _parameter=""
	local funktions_name=""
	local c=0
	local return_value=""
	local anz_parameter=0
	declare -a tmp_array
	declare -a _parameter
	#------------------------------------------

	funktions_name=${FUNCNAME}
	anz_parameter=$#  # fängt bei 1 an, array bei 0 !

	_parameter=(${@^^})   # uppercase=^^ , lowercase ^h

	for (( c=0;c<$#;c++ ))
	do
		case ${_parameter[$c]} in 
			 
			 "DE")   tmp_array[0]=$(date "+%d.%m.%Y")    	# Datum GErmany Format
			        ;; 	 
			 "W")	tmp_array[1]=$(date "+%A")				# Wochentag
			 		;;           
			 "DW")	tmp_array[2]=$(date "+%A: %d.%m.%Y")	# Wochentag + Datum
			 		;;
			 "T")	tmp_array[3]=$(date "+%H:%M:%S")		# Uhrzeit
			 		;;	 		
			 "M")	tmp_array[4]=$(date "+%h") 				# Monat
			 		;;	
			 "EN")	tmp_array[5]=$(date "+%F") 				# JJJJ-MM-TT ENglisches Format
			 		;;			 

			   *)	echo "Datumsformat unbekannt!"	>> error.log
	  	esac
	
	done  			   	
	c=0
	for (( c=0;c<=5;c++ ))
	do
		if [[ -n "${tmp_array[$c]}" ]]   # leer = -z; nicht leer = -n
		then	
			return_value=$return_value${tmp_array[$c]}
		fi	
	done
	echo $return_value
  	#echo ${tmp_array[0]}"|"${tmp_array[1]}"|"${tmp_array[2]}"|"${tmp_array[3]}"|"${tmp_array[4]}"|"${tmp_array[5]}"|"
}

countdown()
{
	local _counter=$3
	local _counter_char=$4
	local _count_char=$5
	local _up_down=$6
	local _blank_line=""
	local _blank=""
	local _del_char=""
	local _c
	local _i=1
	local _symbol='░'
	local _symbol_line=""
	local _z=$1
	local _s=$2


	if [[ "$_count_char" = "" ]]
	then
		_count_char=$_symbol    # default symbol
	fi	


	if [[ "$_up_down" = "" ]]
	then
		_up_down="+"    	   # default hoch-zählen
	fi	

	cursor_off

	if (( $_counter == 0 ))
	then	
		if [[ "$_up_down" = "+" ]]
		then	
			# Balken Counter up
			_c=0
			while (( $_c < $_counter_char ))
			do
				_symbol_line=$_symbol_line$_count_char
				goto_xy_write $_z $_s $_symbol_line
				sleep 1.2
				_c=$((_c+1))
			done
		else
			# Balken Counter down
		    for (( _i; $_i<=${#_count_char}; _i++ ))
			do
				_blank=$_blank"_"
			done	
			_i=1
			for (( _i; $_i<=$_counter_char; _i++ ))
			do
				_symbol_line=$_symbol_line$_count_char
				_blank_line=$_blank_line$_blank
			done
			_c=$_counter_char	
			while (( $_c > 0 ))
			do
				goto_xy_write $_z $_s $_symbol_line 
				sleep 1.2
				goto_xy_write $_z $_s $_blank_line
				_symbol_line=${_symbol_line::-${#_count_char}}			
				_c=$(( _c-1 ))
			done

			#goto_xy_write $_z $_s $_blank_line				
		fi
	else
		if (( $_counter > 0 ))
		then	
			_c=1
			while (( $_c <= $_counter ))
			do
				goto_xy_write $_z $_s $_c
				sleep 1.2
				_c=$((_c+1))
			done	
		else
			_c=$(( _counter * (-1) ))
			while (( $_c >= 0 ))
			do
				goto_xy_write $_z $_s $_c
				sleep 1.2
				_c=$((_c-1))
			done	
		fi	
	fi
	printf '%s\n'
	cursor_on

}

#clear
#countdown 3 5 0 6 '░' -