#!/bin/bash
#
# Program: kassensystem_installation
# ProgramArt: AL      # AL=Standalone, SP=SubProgramm, INC=IncludeProgramm, ALR=StandaloneRemote
# Version: 1.0.0
# Begin_Development: 20.05.2021
# Develop_Change: 12.10.2021
# State of development: 21.11.2021
#-------------------------------
# Author: Uwe von Royen by UvRNC
#-------------------------------
# Develop-OS: Ubuntu 20.04.1
# Hardware: Intel/AMD Linux-PC + EPSON TM-T8xx Drucker
# 
#------------------------------------------------------


function main()
{

    . const/fix_change_mask_variable  
    . include_functions/netz_install.inc
    . include_functions/system_enviroment.inc

    local function_name=${FUNCNAME[0]}
    local error_code=0
    local return_value=0
    local rt=0

    #---------------------------------
    while [ $return_value -eq 0 ]
    do

        logging $error_code $function_name
        mask_draw "" "" ""    # format: Parameter_1=Bildschirm-Nr, Parameter_2=Bildschirm-Text-1, Parameter_3=Bildschirm-Text_2
        return_value=$?
        if (( return_value == 1 ))  
        then
            if [ ! -f $f_data_03 ]
            then
                echo "[Mask-1]" >> "$f_data_03" 
                global_array_string=$(copy_dummy_file_to_input.data)     # copy_dummy_to_input
                global_array=($global_array_string)                      # copy string to array
            fi    
            mask_edit "" 15   # Parameter ScreenNr , Anzahl der Inputzeilen
            return_value=$?
        fi 
        
        if (( $return_value == 27 )) # ESC
        then
            error_code=927
            logging $error_code $function_name
            return_value=27  #########
        else
            auswertung_netz_optionen "$f_data_04" $return_value
            return_value=$? 
            system_umgebung "${global_network_array[*]}"
        fi    
    done

    #echo "echo string:"${mask_string[*]}
}


#-------------------------
#           main 
#-------------------------

#gnome-terminal --geometry=84x40+500+0
#gnome-terminal maximize
#xfce4-terminal --maximize 
. sudo_on
. include_functions/time_tools.inc
. include_functions/cursor_tools.inc 
. include_functions/logging.inc
. include_functions/question_jn.inc
. include_functions/key_tools.inc
. include_functions/mask_draw.inc
. include_functions/mask_edit.inc

global_error_code=0
global_array_string=""

local _answer=1
declare -a global_array="" # nimmt die input-werte auf!
declare -a mask_string=""
declare -a global_network_array="" # liest die Werte von f_data_04 ein

ctrl_c_off # [CTRL+C] ist ausgeschaltet!
sudo_on
#global_network_array[0]="0"
echo "Starte das Programm"
main
ctrl_c_on # CTRL+C] einschalten
echo
echo
goto_xy_write 28 31 "Reboot den PC: [J]/[N]"
goto_xy_write 28 54 ""
question_jn
_answer=$?
if (( $_answer == 0 ))
then
    goto_xy_write 28 15 "Achtung das System wird in 6 Sekunden neu gebootet!"
    countdown 28 42 -9 
    sudo reboot
fi  
#echo "<"${global_network_array[@]}">"

#clear
echo
