#!/bin/bash
#
# -> dpkg -l xfce4-terminal
# aptitude show terminator Zustand: nicht installiert/installiert
#
#################################################################
#
# Program: 'start' zum starten des Programmes 'kassensystem_installation_direct'
# ProgramArt: AL      # AL=Standalone, SP=SubProgramm, INC=IncludeProgramm, ALR=StandaloneRemote
# Version: 1.0.0
# Begin_Development: 07.12.2021
# Develop_Change: 08.12.2021
# State of development: 08.12.2021
#-------------------------------
# Author: Uwe von Royen by UvRNC
#-------------------------------
# Develop-OS: Ubuntu 20.04.1
# Hardware: Intel/AMD Linux-PC + EPSON TM-T8xx Drucker
# 
#------------------------------------------------------

# widthxheight±xoff±yoff
# Ist xterm installiert

term_install()
{
	local term=$1
	local window_name=$2
	local make_test=$3
	local return_value= # 0 enspricht ausnahmweise hier Fehler!, Terminal-Emulation konnte nicht gefunden werden!

   
	if [[ -z $make_test ]] && [[ -z $term ]]
	then
		sudo "./kassensystem_installation.sh"
		exit
	fi	
    echo ">"$act_pid


	if [[ -f $(which "$term" 2>/dev/null) ]]
	then
	        case $term in 

			xterm)  xterm +sb -T $window_name -fa 'Monopace' -fs 12 -geometry 80x30+300+50  -e "sudo ./kassensystem_installation.sh $act_pid"& 
				 	return_value=10
					;;
   xfce4-terminal)	xfce4-terminal -T $window_name --geometry=80x30+300+50 -e "sudo ./kassensystem_installation.sh $act_pid"&
   					#echo $TERM
   					#xfce4-terminal -T $window_name --geometry=80x30+300+50 -e "sudo ./kassensystem_installation.sh $act_pid"&
   					
   					return_value=11
   					;;	
	   terminator)  terminator --geometry=650x500+300+50 -T $window_name -e "sudo ./kassensystem_installation.sh $act_pid"&
				 	return_value=12	
				 	;;
	      konsole)	konsole --hide-menubar --hide-tabbar --geometry 800x500+300+50 -e "sudo ./kassensystem_installation.sh $act_pid"&
				 	return_value=13	
				 	;;
   gnome-terminal)	gnome-terminal --geometry=80x30+300+50  --title="KssEH" --command="sudo ./kassensystem_installation.sh $act_pid"&
				 	return_value=14	
				 	;;				
	         rxvt)	# noch nicht implementiert!
				 	return_value=15	
				 	;; 

				*)  return_value=0	
					;;
			esac

	fi

	sleep 0.5
	kill -9 $PPID
	
}

echo "22"
#term_install 													# auf Server ohne GUI, z.B.: ubuntu server 20.04
#---------------------------------------------------------------
#term_install "xterm" "Network-Mask"							# -> GUI nicht vorhanden,Linux standartmäßig mit
																# einer Terminalemulation meistens "xterm" ausgestattet!
#---------------------------------------------------------------
#term_install "xfce4-terminal" "Network-Mask" "terminal-test" 	# -> GUI vorhanden ist,also auch auf Wunsch mehere
																# verschieden Terminal auf Wunsch möglich!
# --------------------------------------------------------------
# Hier weitere Terminal, die implementiert sind
#echo $(term_install "terminator" "Network-Mask")
echo $(term_install "gnome-terminal" "Network-Mask")
#echo $(term_install "rxvt" "Network-Mask" )
#echo $(term_install "konsole" "Network-Mask" )

